

-- PreConditions: None
-- PostConditions: None
-- Comments: updates the selected log file.
function DKPMasterLogFrame_OnClick(arg1)
		
	local buttonName = this:GetName()
	local indexFromButton = 0

	
	for i=1, DKPM_numFrame2entries do
		local button = "DKPMaster_LogFrame_entry"..i
		if(buttonName==button) then
			indexFromButton = i;
		end
	end
		
	DKPMaster_RefreshLogs();  --clears any highlights
	local r=1
	local g=1
	local b=0
	local a=1
	getglobal("DKPMaster_LogFrame_entry"..indexFromButton.."_location"):SetVertexColor(r, g, b, a)
	getglobal("DKPMaster_LogFrame_entry"..indexFromButton.."_boss"):SetVertexColor(r, g, b, a)
	getglobal("DKPMaster_LogFrame_entry"..indexFromButton.."_date"):SetVertexColor(r, g, b, a)
		
	DKPMLogtotalIndex = indexFromButton + DKPM_LogListIndex - 1;  --index was off by 1 somehow

	local tempLocation;
	local tempBoss;
	local tempDate;
	local tempDKP;
	
	local counter = 0;
	for i,raidevent in DKPM_DKP_LOG do
		tempLocation = raidevent.location;
		tempBoss = raidevent.boss;
		tempDate = raidevent.date;
		tempDKP = raidevent.dkp;
		
		counter = counter + 1;
		if(counter == DKPMLogtotalIndex) then 
			break;
		end
	end 
	
	DKPMLogtotalIndexLocation = tempLocation;
	DKPMLogtotalIndexBoss = tempBoss;
	DKPMLogtotalIndexDate = tempDate;

	getglobal("DKPMaster_LogShowFrame"):Show();
	getglobal("DKPMaster_LogShowDateBox"):SetText(tempDate);
	getglobal("DKPMaster_LogShowLocationBox"):SetText(tempLocation);
	getglobal("DKPMaster_LogShowBossBox"):SetText(tempBoss);
	getglobal("DKPMaster_LogShowDKPBox"):SetText(tempDKP);
	
end


-- PreConditions: None
-- PostConditions: None
-- Comments: function moves the log list up and down
function DKPMasterLogFrame_ScrollList(inc)
	
	if(inc == "+")then
		local temp = DKPM_LogListIndex + 20
		if(temp <= table.getn(DKPM_DKP_LOG) ) then
			DKPM_LogListIndex = temp
		end
	elseif (inc == "-") then
		local temp = DKPM_LogListIndex - 20
		if(temp > 0 ) then
			DKPM_LogListIndex = temp
		end
	end
	DKPMaster_RefreshLogs();  -- refreshes the change
end

-- PreConditions: None
-- PostConditions: None
-- Comments: function moves the log list up and down
function DKPM_LogFrame_Delete()
	local counter = 1;
	local dkpcounter = 0;
	
	for i,raidevent in DKPM_DKP_LOG do
		if(raidevent.location == DKPMLogtotalIndexLocation and raidevent.boss == DKPMLogtotalIndexBoss and raidevent.date == DKPMLogtotalIndexDate) then
			--skrim("testing remove log: remove disabled in code.");
			-- adjust the DKPM_DKP table before Delete
			-- loop through all players and adjust dkp back into the live dkp.
			for j,players in raidevent.players do
				if(players.name ~= nil and players.class ~= nil) then
					-- add the total dkp of all items for Player
					dkpcounter = 0;
					for m,playersitems in players.item do
						dkpcounter = dkpcounter + playersitems.itemdkp;
					end
					-- here to find player in the live dkp data
					for k,localdkp in DKPM_DKP do
						if(localdkp.name == players.name) then
							localdkp.dkp = localdkp.dkp - raidevent.dkp;
							localdkp.dkp = localdkp.dkp + dkpcounter;
						end
					end
				end
			end		
			table.remove(DKPM_DKP_LOG,counter);
			DKPMaster_RefreshLogs();  -- refreshes the change
			return;
		end
		counter = counter + 1;
	end 
	DKPMaster_RefreshLogs();  -- refreshes the change
	DKPMaster_RefreshRoster();
end

-- PreConditions: None
-- PostConditions: None
-- Comments: function moves the log list up and down
function DKPM_LogFrame_DeleteAll()
	local dkpcounter = 0;
	
	-- need to subtract DKP from live dkp.
	for i,raidevent in DKPM_DKP_LOG do
		--skrim("testing remove log: remove disabled in code.");
		-- adjust the DKPM_DKP table before Delete
		-- loop through all players and adjust dkp back into the live dkp.
		for j,players in raidevent.players do
			if(players.name ~= nil and players.class ~= nil) then
				-- add the total dkp of all items for Player
				dkpcounter = 0;
				for m,playersitems in players.item do
					dkpcounter = dkpcounter + playersitems.itemdkp;
				end
					
				-- here to find player in the live dkp data
				for k,localdkp in DKPM_DKP do
					if(localdkp.name == players.name) then
						localdkp.dkp = localdkp.dkp - raidevent.dkp;
						localdkp.dkp = localdkp.dkp + dkpcounter;
					end
				end
			end
		end		
	end 
	DKPM_DKP_LOG = {};
	DKPMaster_RefreshLogs();  -- refreshes the change
	DKPMaster_RefreshRoster();
end

-- PreConditions: None
-- PostConditions: None
-- Comments:
function DKPMaster_HideLogShowFramePopup()
  --DKPMaster_PopupFrame:Hide()
  --DKPMaster_PopupFrame = nil
  getglobal("DKPMaster_LogShowFrame"):Hide();
  --getglobal("DKPMaster_Frame2"):Show();
  DKPMaster_RefreshRoster();
end

-- PreConditions: None
-- PostConditions: None
-- Comments:
function DKPMaster_HideLogPopup()
  --DKPMaster_PopupFrame:Hide()
  --DKPMaster_PopupFrame = nil
  getglobal("DKPMaster_LogFrame"):Hide();
  getglobal("DKPMaster_Frame2"):Show();
end
