<?php
/**
 Contains MySQL functions and updates EQdkp tables.
*/


function checkdb($table_prefix) {
  $result = sqlQuery("SHOW COLUMNS FROM {$table_prefix}raids LIKE 'raid_endtime'");
  $row = sqlGetRow($result);
  sqlFreeResult($result);
  $olddb = !$row;

  if ($olddb) {
    $result = sqlQuery("ALTER TABLE {$table_prefix}raid_attendees ADD inraidtime INT UNSIGNED NOT NULL,
                        ADD outraidtime INT UNSIGNED NOT NULL, ADD member_id INT UNSIGNED NOT NULL;");
    $result = sqlQuery("ALTER TABLE {$table_prefix}raid_attendees ADD INDEX (member_id);");
    $result = sqlQuery("ALTER TABLE {$table_prefix}raids ADD raid_endtime INT UNSIGNED NOT NULL, ADD event_id INT UNSIGNED NOT NULL;");
    $result = sqlQuery("ALTER TABLE {$table_prefix}raids ADD INDEX (event_id);");

    if ($result) $olddb = false;
  }
  
  $row = sqlSelect("{$table_prefix}raid_attendees", 'member_id = 0', 'count(*) as c');
  if ($row['c'] > 0) {
    sqlQuery("UPDATE {$table_prefix}raid_attendees as ra left join {$table_prefix}members as m on ra.member_name = m.member_name SET ra.member_id = m.member_id");
    $nrrafixed = sqlAffectedRows();
    sqlQuery("UPDATE {$table_prefix}raids as r left join {$table_prefix}events as e on r.raid_name = e.event_name SET r.event_id = e.event_id");
    $nrefixed = sqlAffectedRows();

    echo("Fixed data, sorry it took so long. ".($nrrafixed+$nrefixed)." rows updated.<br>");
  }
}


function formatSql($input) {
  switch (gettype($input)) {
    case "array" :
      $output = array();
      foreach ($input as $key => $value) $output[$key] = formatSql($value);
      return $output;
    case "integer" :
    case "double" :
      return $input;
    case "null" :
      return "NULL";
    case "boolean" :
      return $input ? 1 : 0;
    default :
      return "'" . str_replace(array("\\", "'"), array("\\\\", "\\'"), $input) . "'";
  }
}

function sqlConnect($username, $password, $host = 'localhost') {
  $GLOBALS['SqlLink'] = mysql_connect($host, $username, $password);
  if (!$GLOBALS['SqlLink']) sqlError();
}

function sqlDisconnect() {
  if ($GLOBALS['SqlLink']) return mysql_close($GLOBALS['SqlLink']);
}

function sqlSetDatabase($db) {
  if (!mysql_select_db($db)) sqlError();
}

function sqlGetErrormsg() {
  return mysql_error();
}

function sqlAffectedRows() {
  return mysql_affected_rows($GLOBALS['SqlLink']);
}

function sqlQuery($query) {
  $GLOBALS['SqlQueries'][] = $query;
  $result = mysql_query($query);
  if ($result === false) sqlError();
  return $result;
}

function sqlGetRow($result) {
  return mysql_fetch_array($result, MYSQL_ASSOC);
}

function sqlGetNumRows($result) {
  return mysql_num_rows($result);
}

function sqlFreeResult($result) {
  mysql_free_result($result);
}

function sqlSelect($table, $where = '', $what = '*' )
{
  $query = "SELECT $what FROM $table" . ($where ? " WHERE $where" : '');
  $result = sqlQuery($query);
  $row = mysql_fetch_array($result);
  mysql_free_result($result);
  return $row;
}

function sqlSelectMany($table, $where = '', $what = '*', $more = '' )
{
  $query = "SELECT $what FROM $table" . ($where ? " WHERE $where" : '') . ($more ? " $more" : '');
  $result = sqlQuery($query);
  $list = array();
  while ( $row = mysql_fetch_array($result) ) {
    $list[] = $row;
  }
  mysql_free_result($result);
  return $list;
}

function sqlInsert($table, $data)
{
  $query = "INSERT INTO $table (" . join(',', array_keys($data)) .
           ') VALUES (' . join(',', array_values($data)) . ')';
  sqlQuery($query);
  return sqlGetLastID();
}

function sqlUpdate($table, $data, $where = '')
{
  $list = array();
  foreach ($data as $key => $value) {
    $list[] = $key . '=' . $value;
  }
  $query = "UPDATE $table SET " . join(',', $list) . ($where ? " WHERE $where" : '');
  sqlQuery($query);
}

function sqlDelete($table, $where)
{
  $query = 'DELETE FROM ' . $table . ($where ? " WHERE $where" : '');
  sqlQuery($query);
}

function sqlGetLastID() {
  return mysql_insert_id();
}

function sqlError() {
  echo "<html>";
  echo "MySQL: " . sqlGetErrormsg() . "<br>";
  echo "Queries:<br>";
  foreach ($GLOBALS['SqlQueries'] as $query) {
    echo $query . "<br>";
  }
  echo "</html>";
  exit;
}



/*
function getTables ( ) {
  $result = mysql_list_tables($this->db, $this->connection);
  for ($i = 0; $i < mysql_num_rows($result); $i++) {
    $list[] = mysql_tablename($result, $i);
  }
  return $list;
}
function getDatabases ( ) {
  $result = mysql_list_dbs($this->connection);
  for ($i = 0; $i < mysql_num_rows($result); $i++) {
    $list[] = mysql_tablename($result, $i);
  }
  return $list;
}
function getFields ( $table ) {
  $result = mysql_list_fields($this->db, $table, $this->connection);
  $nrfields = mysql_num_fields($result);
  for ($i = 0; $i < $nrfields; $i++) {
    $fields[] = array(
      'Type'   => mysql_field_type($result, $i),
      'Name'   => mysql_field_name($result, $i),
      'Length' => mysql_field_len($result, $i),
      'Flags'  => explode(' ', mysql_field_flags($result, $i))
    );
  }
  return $fields;
}
*/